Index: tmp/org.txm.libs.msoffice/src/org/txm/libs/msoffice/ReadExcel.java
===================================================================
--- tmp/org.txm.libs.msoffice/src/org/txm/libs/msoffice/ReadExcel.java	(revision 3060)
+++ tmp/org.txm.libs.msoffice/src/org/txm/libs/msoffice/ReadExcel.java	(revision 3061)
@@ -95,6 +95,7 @@
 		for (int rowIndex = 0; rowIndex < nRows; rowIndex++) {
 			Row row = ws.getRow(rowIndex);
 			if (row == null) continue;
+			
 			for (int i = 0; i < columnIdxToTest.size(); i++) {
 				int colIndex = columnIdxToTest.get(i);
 				
@@ -433,6 +434,7 @@
 		for (int rowIndex = 0; rowIndex < nRows; rowIndex++) {
 			Row row = ws.getRow(rowIndex);
 			if (row == null) continue;
+			
 			for (int i = 0; i < columnIdxToTest.size(); i++) {
 				int colIndex = columnIdxToTest.get(i);
 				
@@ -541,6 +543,7 @@
 	protected void _getRecord() {
 		record = new HashMap<>();
 		Row row = ws.getRow(iRow);
+		if (row == null) return;
 		
 		for (int colIndex = 0; colIndex < header.length; colIndex++) {
 			String col = header[colIndex];
@@ -601,7 +604,10 @@
 			}
 			
 			int nRows = ws.getPhysicalNumberOfRows();
-			if (nRows == 0) return null;
+			if (nRows == 0) {
+				System.out.println("** Excel2XML: no row to process. Aborting.");
+				return null;
+			}
 			
 			Row firstRow = ws.getRow(0);
 			int colMax = firstRow.getLastCellNum();
@@ -613,6 +619,8 @@
 			
 			for (int rowIndex = 0; rowIndex < nRows; rowIndex++) {
 				Row row = ws.getRow(rowIndex);
+				if (row == null) continue;
+				
 				ArrayList<String> dataLine = new ArrayList<>();
 				data.add(dataLine);
 				for (int colIndex = 0; colIndex < colMax; colIndex++) {
Index: tmp/org.txm.internalview.rcp/src/org/txm/internalview/rcp/editors/InternalViewEditor.java
===================================================================
--- tmp/org.txm.internalview.rcp/src/org/txm/internalview/rcp/editors/InternalViewEditor.java	(revision 3060)
+++ tmp/org.txm.internalview.rcp/src/org/txm/internalview/rcp/editors/InternalViewEditor.java	(revision 3061)
@@ -125,7 +125,7 @@
 		});
 		
 		// Word properties selector
-		propertiesSelector = new PropertiesSelector<WordProperty>(parametersArea);
+		propertiesSelector = new PropertiesSelector<>(parametersArea);
 		propertiesSelector.setLayoutData(new GridData(GridData.CENTER, GridData.CENTER, false, true));
 		propertiesSelector.setLayout(new GridLayout(3, false));
 		try {
@@ -138,7 +138,7 @@
 		propertiesSelector.addSelectionListener(computeSelectionListener);
 		
 		// Structural unit properties selector
-		structuralUnitPropertiesSelector = new PropertiesSelector<StructuralUnitProperty>(parametersArea);
+		structuralUnitPropertiesSelector = new PropertiesSelector<>(parametersArea);
 		structuralUnitPropertiesSelector.setLayoutData(new GridData(GridData.CENTER, GridData.CENTER, false, true));
 		structuralUnitPropertiesSelector.setLayout(new GridLayout(3, false));
 		structuralUnitPropertiesSelector.setTitle(InternalViewUIMessages.structuralProperties);
@@ -188,7 +188,7 @@
 				int nlines = internalView.getSegmentLength();
 				List<WordProperty> props = internalView.getProperties();
 				
-				ArrayList<Object[]> lines = new ArrayList<Object[]>();
+				ArrayList<Object[]> lines = new ArrayList<>();
 				for (int i = 0; i < nlines; i++) {
 					lines.add(new String[props.size()]);
 				}
@@ -237,17 +237,17 @@
 	}
 	
 	
-	HashMap<Property, TableViewerColumn> columns = new HashMap<Property, TableViewerColumn>();
+	HashMap<Property, TableViewerColumn> columns = new HashMap<>();
 	
-	HashMap<TableViewerColumn, Integer> columnsOrder = new HashMap<TableViewerColumn, Integer>();
+	HashMap<TableViewerColumn, Integer> columnsOrder = new HashMap<>();
 	
 	private void initColumns() {
 		
 		for (TableViewerColumn col : columns.values()) {
 			col.getColumn().dispose();
 		}
-		columnsOrder = new HashMap<TableViewerColumn, Integer>();
-		columns = new HashMap<Property, TableViewerColumn>();
+		columnsOrder = new HashMap<>();
+		columns = new HashMap<>();
 		
 		if (internalView == null) {
 			// System.out.println("REMOVE NON USED COLUMNS");
@@ -298,7 +298,7 @@
 			else {
 				query.append(col.getText() + "=\""); //$NON-NLS-1$
 			}
-			HashSet<String> values = new HashSet<String>();
+			HashSet<String> values = new HashSet<>();
 			for (int i = 0; i < indexes.length; i++) {
 				int idx = indexes[i];
 				values.add(CQLQuery.addBackSlash(items[idx].getText(icol)));
@@ -358,7 +358,6 @@
 		navigation.setCurrentPosition(this.getResult().getCurrentPage());
 		navigation.setMaxPosition(this.getResult().getSegmentsCount());
 		
-		navigation.setInfoLineText(" / " + this.getResult().getSegmentsCount()); //$NON-NLS-1$
 		navigation.refresh();
 		navigationPanel.layout();
 	}
Index: tmp/org.txm.tigersearch.rcp/groovy/org/txm/scripts/importer/tigersearch/tigersearchLoader.groovy
===================================================================
--- tmp/org.txm.tigersearch.rcp/groovy/org/txm/scripts/importer/tigersearch/tigersearchLoader.groovy	(revision 3060)
+++ tmp/org.txm.tigersearch.rcp/groovy/org/txm/scripts/importer/tigersearch/tigersearchLoader.groovy	(revision 3061)
@@ -33,7 +33,6 @@
 import org.txm.metadatas.*
 import org.txm.objects.*
 import org.txm.importer.scripts.xmltxm.*
-import org.txm.tokenizer.TokenizerClasses
 import org.txm.utils.*
 import org.txm.utils.i18n.*
 import org.txm.importer.xtz.*
Index: tmp/org.txm.tigersearch.rcp/src/org/txm/function/tigersearch/TSIndex.java
===================================================================
--- tmp/org.txm.tigersearch.rcp/src/org/txm/function/tigersearch/TSIndex.java	(revision 3060)
+++ tmp/org.txm.tigersearch.rcp/src/org/txm/function/tigersearch/TSIndex.java	(revision 3061)
@@ -37,75 +37,80 @@
 import org.txm.utils.logger.Log;
 
 public class TSIndex extends Index {
-
-
+	
+	public static final String EDITIONID = "editionId";
+	
 	public TSIndex(CQPCorpus corpus, List<WordProperty> props)
 			throws CqiClientException, IOException, CqiServerError {
 		super(corpus);
 		this.setParameters(new CQLQuery("[]"), props, null, null, null, null);
 	}
-
+	
 	public TSIndex(CQPCorpus corpus, CQLQuery query, List<WordProperty> props)
 			throws CqiClientException, IOException, CqiServerError {
 		super(corpus);
 		this.setParameters(query, props, null, null, null, null);
 	}
-
-//	public TSIndex(Partition partition, CQLQuery query, List<WordProperty> props)
-//			throws CqiClientException, IOException, CqiServerError {
-//		super(partition);
-//		this.setParameters(query, props, null, null, null, null);
-//	}
-
-
-	boolean isTIgerInitialized = false;
+	
+	// public TSIndex(Partition partition, CQLQuery query, List<WordProperty> props)
+	// throws CqiClientException, IOException, CqiServerError {
+	// super(partition);
+	// this.setParameters(query, props, null, null, null, null);
+	// }
+	
+	
+	boolean isTigerInitialized = false;
+	
 	private TSCorpus tscorpus;
+	
 	private TSResult tsresult;
+	
 	private boolean initTIGERSearch() {
-		if (isTIgerInitialized) return isTIgerInitialized;
-
+		if (isTigerInitialized) return isTigerInitialized;
+		
 		String id = getCorpus().getMainCorpus().getName();
-		File configfile = new File(getCorpus().getProjectDirectory(),"tiger/tigersearch.logprop");
+		File configfile = new File(getCorpus().getProjectDirectory(), "tiger/tigersearch.logprop");
 		File registrydir = new File(getCorpus().getProjectDirectory(), "tiger");
-
+		
 		TSCorpusManager manager = new TSCorpusManager(registrydir, configfile);
 		if (manager.isInitialized()) {
 			tscorpus = manager.getCorpus(id);
 			if (tscorpus == null) {
-				System.out.println("TIGERSearch corpus not found in "+registrydir);
-				isTIgerInitialized = false;
+				System.out.println("TIGERSearch corpus not found in " + registrydir);
+				isTigerInitialized = false;
 			}
-
-			isTIgerInitialized = true;
+			
+			isTigerInitialized = true;
 		}
-		return isTIgerInitialized;
+		return isTigerInitialized;
 	}
-
+	
 	@Override
 	/**
 	 * count tokens.
 	 *
 	 * @param corp the corp
 	 * @return true, if successful
-	 * @throws CqiClientException 
-	 * @throws CqiServerError 
-	 * @throws IOException 
+	 * @throws CqiClientException
+	 * @throws CqiServerError
+	 * @throws IOException
 	 */
 	protected boolean scanCorpus(CQPCorpus corp) throws CqiClientException, IOException, CqiServerError {
-
+		
 		if (!initTIGERSearch()) return false;
-
+		
 		// get the cqp result of the query
-		//	long time = System.currentTimeMillis();
-		//		QueryResult result = corp.query(getQuery(), "index", true); //$NON-NLS-1$
-		boolean isTargetUsed = false;//CQPSearchEngine.getCqiClient().subCorpusHasField(result.getQualifiedCqpId(), ICqiClient.CQI_CONST_FIELD_TARGET);
-
+		// long time = System.currentTimeMillis();
+		// QueryResult result = corp.query(getQuery(), "index", true); //$NON-NLS-1$
+		boolean isTargetUsed = false;// CQPSearchEngine.getCqiClient().subCorpusHasField(result.getQualifiedCqpId(), ICqiClient.CQI_CONST_FIELD_TARGET);
+		
 		// System.out.println("nLines : "+nLines);
 		List<Match> matches;
 		try {
 			matches = getMatchesFromTSQuery(corp);
-		} catch (Exception e1) {
-			System.out.println("Error while queing TIGERSearch: "+e1);
+		}
+		catch (Exception e1) {
+			System.out.println("Error while queing TIGERSearch: " + e1);
 			e1.printStackTrace();
 			return false;
 		}
@@ -114,10 +119,10 @@
 			return false;
 		}
 		this.nTotalTokens += nbresults; // get number of tokens
-
+		
 		// count matches
 		// time = System.currentTimeMillis();
-		List<Integer> allpositions = new ArrayList<Integer>();
+		List<Integer> allpositions = new ArrayList<>();
 		for (int j = 0; j < nbresults; j++) {
 			Match match = matches.get(j);
 			// beginingOfKeywordsPositions.add(match.getStart()); // get the
@@ -125,19 +130,20 @@
 			// lengthOfKeywords.add(match.size());// get the last index
 			if (isTargetUsed) {
 				allpositions.add(match.getTarget());
-			} else {
+			}
+			else {
 				for (int i = match.getStart(); i <= match.getEnd(); i++)
 					allpositions.add(i);
 			}
 		}
-
+		
 		int[] allpositionsarray = new int[allpositions.size()];
 		int pcount = 0;
 		for (int p : allpositions)
 			allpositionsarray[pcount++] = p;
-
+		
 		// time = System.currentTimeMillis();
-		HashMap<Property, int[]> propsId = new HashMap<Property, int[]>();
+		HashMap<Property, int[]> propsId = new HashMap<>();
 		for (Property property : pProperties) {
 			try {
 				if (property instanceof StructuralUnitProperty) {
@@ -146,15 +152,17 @@
 									property.getQualifiedName(),
 									allpositionsarray);
 					propsId.put(property, structs);
-				} else {
+				}
+				else {
 					int[] indices = CorpusManager.getCorpusManager()
 							.getCqiClient().cpos2Id(
 									property.getQualifiedName(),
 									allpositionsarray);
 					propsId.put(property, indices);
 				}
-			} catch (Exception e) {
-				System.out.println("Error while properties projection: "+e);
+			}
+			catch (Exception e) {
+				System.out.println("Error while properties projection: " + e);
 				Log.printStackTrace(e);
 				return false;
 			}
@@ -175,42 +183,43 @@
 				line.putIds(property, ids);
 			}
 			currentIndex += size;
-
+			
 			String signature = line.getSignature();
-
+			
 			if (counts.containsKey(signature)) // if the counts contains the
-				// signature, increment its
-				// corresponding value
+			// signature, increment its
+			// corresponding value
 			{
 				while (counts.get(signature).size() <= currentpartid)
 					counts.get(signature).add(0);
 				int c = counts.get(signature).get(currentpartid) + 1;
 				counts.get(signature).set(currentpartid, c);
-			} else // else initialize count of the signature to 1
+			}
+			else // else initialize count of the signature to 1
 			{
 				// System.out.println("add new sign "+signature+" of line "+line.toString());
-				ArrayList<Integer> tmp = new ArrayList<Integer>();
+				ArrayList<Integer> tmp = new ArrayList<>();
 				for (int j = 0; j < currentpartid + 1; j++)
 					tmp.add(0);
 				counts.put(signature, tmp);
 				counts.get(signature).set(currentpartid, 1);
-
+				
 				lines.add(line);
 			}
 		}
 		// System.out.println("Time count lines "+(System.currentTimeMillis()-time));
 		// System.out.println("took "+(System.currentTimeMillis()-time));
 		return true;
-
+		
 	}
-
+	
 	private List<Match> getMatchesFromTSQuery(CQPCorpus corp) throws Exception {
-		ArrayList<Match> matches =  new ArrayList<Match>();
+		ArrayList<Match> matches = new ArrayList<>();
 		tsresult = tscorpus.query(pQuery.toString());
 		boolean debug = false;
 		ResultForest forest = tsresult.getForest();
 		MatchResult result = tsresult.getMatchResult();
-
+		
 		int var_ok = 0;
 		String label = "@|pivot";
 		Pattern p = Pattern.compile(label);
@@ -219,48 +228,49 @@
 		}
 		if (var_ok == 0) {
 			System.out.println("** Error in TSIndex: no label '@' or 'pivot' found in TIGERSearch query. Aborting.");
-			return matches; 
-		} else if (var_ok > 1) {
+			return matches;
+		}
+		else if (var_ok > 1) {
 			System.out.println("** Error in TSIndex: too many labels '@' or 'pivot' found in TIGERSearch query. Aborting.");
-			return matches; 
+			return matches;
 		}
-
+		
 		InternalCorpusQueryManager manager = tsresult.getManager();
-		//		Display_Sentence match = null;
-		//		
-		//		if (forest.isNextMatch()) {
-		//			match = forest.nextMatch();
-		//		} else {
-		//			match = null;
-		//		}
-
-		HashSet<String> matchingTnodesID = new HashSet<String>();
-		String EDITIONID = "editionId";
-
+		// Display_Sentence match = null;
+		//
+		// if (forest.isNextMatch()) {
+		// match = forest.nextMatch();
+		// } else {
+		// match = null;
+		// }
+		
+		HashSet<String> matchingTnodesID = new HashSet<>();
+		
 		int size = forest.getForestSize();
-		for ( int match_no = 0 ; match_no < size ; match_no++) {
-			if (debug) System.out.println("Match "+match_no);
+		for (int match_no = 0; match_no < size; match_no++) {
+			if (debug) System.out.println("Match " + match_no);
 			int sentno = result.getSentenceNumberAt(match_no);
 			Sentence sentence = manager.getSentence(sentno);
-
-			result.orderSentenceSubmatches(sentno); 
+			
+			result.orderSentenceSubmatches(sentno);
 			int n = result.getSentenceSubmatchSize(sentno);
-
-			for (int iSubMatch=0; iSubMatch<n; iSubMatch++) {
-				if (debug) System.out.println(" Sub "+iSubMatch);
+			
+			for (int iSubMatch = 0; iSubMatch < n; iSubMatch++) {
+				if (debug) System.out.println(" Sub " + iSubMatch);
 				int[] var_values = result.getSentenceSubmatchAt(sentno, iSubMatch);
 				int value;
-				for (int j=0; j<var_values.length; j++) {
-					if (debug) System.out.println("  Var "+j+" name="+result.getVariableName(j));
+				for (int j = 0; j < var_values.length; j++) {
+					if (debug) System.out.println("  Var " + j + " name=" + result.getVariableName(j));
 					value = var_values[j];
-					if (value>=0) {
+					if (value >= 0) {
 						String var_name = result.getVariableName(j);
 						Node referred = sentence.getNode(value);
 						if (p.matcher(var_name).matches()) {
 							if (referred instanceof T_Node) {
-								if (debug) System.out.println("    Node: "+referred.getFeature(EDITIONID));
+								if (debug) System.out.println("    Node: " + referred.getFeature(EDITIONID));
 								matchingTnodesID.add(referred.getFeature(EDITIONID));
-							} else if (referred instanceof NT_Node) {
+							}
+							else if (referred instanceof NT_Node) {
 								for (T_Node c : getTerminals((NT_Node) referred, sentence)) {
 									matchingTnodesID.add(c.getFeature(EDITIONID));
 								}
@@ -270,71 +280,73 @@
 				}
 			}
 		}
-
-
-		//		while (match != null) {
-		//			if (debug) System.out.println("Match: "+forest.getCurrentMatchNumber()+" Nsub="+forest.getSubMatchesSize());
-		//			Display_Sentence sub = null;
-		//			int[] var_values = match.getSentenceSubmatchAt(sentno,i);
-		//			
-		//			sub = match;
-		//			int nlabel;
-		//			while (sub != null) {
-		//				if (debug) System.out.println(" Sub: "+forest.getCurrentSubMatchNumber());
-		//				Node matchingNode = sub.getMatchSubgraphNode();
-		//				//if (debug) System.out.println(matchingNode.getIncomingEdgeLabel());
-		//				if (matchingNode instanceof T_Node) {
-		//					T_Node node = (T_Node)matchingNode;
-		//					if (debug) System.out.println("  T node: "+node.getFeature(EDITIONID)+" "+node.getFeature("word"));
-		//					matchingTnodesID.add(node.getFeature(EDITIONID));
-		//				} else if (matchingNode instanceof NT_Node) {
-		//					NT_Node ntnode = (NT_Node)matchingNode;
-		//					if (debug) System.out.println("  NT node: "+ntnode.getChilds());
-		//					for (T_Node node : getTerminals(ntnode, sub)) {
-		//						if (debug) System.out.println("   T node: "+node.getFeature(EDITIONID)+" "+node.getFeature("word"));
-		//						matchingTnodesID.add(node.getFeature(EDITIONID));
-		//					}
-		//				}
+		
+		
+		// while (match != null) {
+		// if (debug) System.out.println("Match: "+forest.getCurrentMatchNumber()+" Nsub="+forest.getSubMatchesSize());
+		// Display_Sentence sub = null;
+		// int[] var_values = match.getSentenceSubmatchAt(sentno,i);
 		//
-		//				if (forest.isNextSubMatch()) {
-		//					sub = forest.nextSubMatch();
-		//				} else {
-		//					sub = null;
-		//				}
-		//			}
-		//			
-		//			if (forest.isNextMatch()) {
-		//				match = forest.nextMatch();
-		//			} else {
-		//				match = null;
-		//			}
-		//		}
-
-		HashSet<String> matchingTnodesIDFiltered = new HashSet<String>();
+		// sub = match;
+		// int nlabel;
+		// while (sub != null) {
+		// if (debug) System.out.println(" Sub: "+forest.getCurrentSubMatchNumber());
+		// Node matchingNode = sub.getMatchSubgraphNode();
+		// //if (debug) System.out.println(matchingNode.getIncomingEdgeLabel());
+		// if (matchingNode instanceof T_Node) {
+		// T_Node node = (T_Node)matchingNode;
+		// if (debug) System.out.println(" T node: "+node.getFeature(EDITIONID)+" "+node.getFeature("word"));
+		// matchingTnodesID.add(node.getFeature(EDITIONID));
+		// } else if (matchingNode instanceof NT_Node) {
+		// NT_Node ntnode = (NT_Node)matchingNode;
+		// if (debug) System.out.println(" NT node: "+ntnode.getChilds());
+		// for (T_Node node : getTerminals(ntnode, sub)) {
+		// if (debug) System.out.println(" T node: "+node.getFeature(EDITIONID)+" "+node.getFeature("word"));
+		// matchingTnodesID.add(node.getFeature(EDITIONID));
+		// }
+		// }
+		//
+		// if (forest.isNextSubMatch()) {
+		// sub = forest.nextSubMatch();
+		// } else {
+		// sub = null;
+		// }
+		// }
+		//
+		// if (forest.isNextMatch()) {
+		// match = forest.nextMatch();
+		// } else {
+		// match = null;
+		// }
+		// }
+		
+		HashSet<String> matchingTnodesIDFiltered = new HashSet<>();
 		for (String s : matchingTnodesID) {
 			if (s == null || s.length() == 0 || s.endsWith("_dupl")) {
-
-			} else {
+				
+			}
+			else {
 				matchingTnodesIDFiltered.add(s);
 			}
 		}
-
-		if (debug) System.out.println("Matching ids: "+matchingTnodesIDFiltered);
+		
+		if (debug) System.out.println("Matching ids: " + matchingTnodesIDFiltered);
 		String[] strings = new String[matchingTnodesIDFiltered.size()];
 		int i = 0;
-		for (String s : matchingTnodesIDFiltered) strings[i++] = s;
+		for (String s : matchingTnodesIDFiltered)
+			strings[i++] = s;
 		matchingTnodesIDFiltered = null;
-
+		
 		matches = buildMatches_CQI(strings);
 		strings = null;
-
+		
 		// one word per match ! the word is inside one of the CQP (sub-)Corpus matches
-		List<Match> finalMatches = new ArrayList<Match>();
+		List<Match> finalMatches = new ArrayList<>();
 		List<Match> corpusMatches = corp.getMatches();
 		int iCorpusStart = 0;
-		for (int iMatch = 0 ; iMatch < matches.size() ; iMatch++) {
+		for (int iMatch = 0; iMatch < matches.size(); iMatch++) {
 			Match m1 = matches.get(iMatch);
-			for (int iCorpus = iCorpusStart ; iCorpus < corpusMatches.size() ; iCorpus++) {
+			for (int iCorpus = iCorpusStart; iCorpus < corpusMatches.size(); iCorpus++) {
 				Match m2 = corpusMatches.get(iCorpus);
 				if (m2.getStart() <= m1.getStart() && m1.getEnd() <= m2.getEnd()) {
 					finalMatches.add(m1);
@@ -346,72 +358,77 @@
 		matches = null;
 		corpusMatches = null;
 		return finalMatches;
-
+		
 	}
-
+	
 	private ArrayList<Match> buildMatches_CQI(String[] strings) throws CqiClientException, IOException, CqiServerError {
 		boolean debug = false;
-		ArrayList<Match> matches = new ArrayList<Match>();
+		ArrayList<Match> matches = new ArrayList<>();
 		AbstractCqiClient CQI = CQPSearchEngine.getCqiClient();
 		Property idProperty = getCorpus().getProperty("id");
-
-		if (debug) System.out.println("Call CQI.str2Id with strings.len="+strings.length);
+		
+		if (debug) System.out.println("Call CQI.str2Id with strings.len=" + strings.length);
 		if (debug) System.out.println(Arrays.toString(strings));
 		if (debug) System.out.flush();
-
+		
 		int[] ids = CQI.str2Id(idProperty.getQualifiedName(), strings);
-
-		if (debug) System.out.println("Call CQI.idList2Cpos with strings.len="+ids.length);
+		
+		if (debug) System.out.println("Call CQI.idList2Cpos with strings.len=" + ids.length);
 		if (debug) System.out.println(Arrays.toString(ids));
 		if (debug) System.out.flush();
-
-		HashSet<Integer> positionsSet = new HashSet<Integer>();
+		
+		HashSet<Integer> positionsSet = new HashSet<>();
 		for (int id : ids) {
 			int[] positions = CQI.id2Cpos(idProperty.getQualifiedName(), id);
-			for( int p : positions) positionsSet.add(p);
+			for (int p : positions)
+				positionsSet.add(p);
 		}
-
+		
 		int[] positions = new int[positionsSet.size()];
 		int i = 0;
-		for (int p : positionsSet) positions[i++] = p;
+		for (int p : positionsSet)
+			positions[i++] = p;
 		positionsSet = null;
 		Arrays.sort(positions);
-		if (debug) System.out.println("Positions: "+Arrays.toString(positions));
-
-		for (int p : positions) matches.add(new Match(p, p, -1));
-
-		//build matches and regroups matches
-		//		int previous = -999;
-		//		int start = -1, end = -1, target = -1;
-		//		for (int p : positions) {
-		//			//System.out.println("P="+p+" start="+start+" end="+end+" target="+target+" Prev="+previous);
-		//			if (p - previous > 1) {
-		//				if (start >= 0) {
-		//					matches.add(new Match(start, end, target));
-		//				}
-		//				start = p;
-		//			}
-		//			end = p;
-		//			previous = p;
-		//		}
-		//		System.out.println(matches);
+		if (debug) System.out.println("Positions: " + Arrays.toString(positions));
+		
+		for (int p : positions)
+			matches.add(new Match(p, p, -1));
+			
+		// build matches and regroups matches
+		// int previous = -999;
+		// int start = -1, end = -1, target = -1;
+		// for (int p : positions) {
+		// //System.out.println("P="+p+" start="+start+" end="+end+" target="+target+" Prev="+previous);
+		// if (p - previous > 1) {
+		// if (start >= 0) {
+		// matches.add(new Match(start, end, target));
+		// }
+		// start = p;
+		// }
+		// end = p;
+		// previous = p;
+		// }
+		// System.out.println(matches);
 		return matches;
 	}
-
-
-	protected static ArrayList<T_Node> EMPTYTERMINALS = new ArrayList<T_Node>();
+	
+	
+	protected static ArrayList<T_Node> EMPTYTERMINALS = new ArrayList<>();
+	
 	public static ArrayList<T_Node> getTerminals(NT_Node ntnode, Sentence sub) {
 		if (ntnode.getChilds().size() == 0) return EMPTYTERMINALS;
-
-		ArrayList<T_Node> terminals = new ArrayList<T_Node>();
+		
+		ArrayList<T_Node> terminals = new ArrayList<>();
 		for (Object o : ntnode.getChilds()) {
-			int n = (Integer)o;
+			int n = (Integer) o;
 			Node node = sub.getNode(n);
 			if (node instanceof T_Node) {
-				terminals.add((T_Node)node);
-			} else if (node instanceof NT_Node) {
-				terminals.addAll(getTerminals((NT_Node)node, sub));
+				terminals.add((T_Node) node);
 			}
+			else if (node instanceof NT_Node) {
+				terminals.addAll(getTerminals((NT_Node) node, sub));
+			}
 		}
 		return terminals;
 	}
Index: tmp/org.txm.tigersearch.rcp/src/org/txm/function/tigersearch/TIGERSearch.java
===================================================================
--- tmp/org.txm.tigersearch.rcp/src/org/txm/function/tigersearch/TIGERSearch.java	(revision 3060)
+++ tmp/org.txm.tigersearch.rcp/src/org/txm/function/tigersearch/TIGERSearch.java	(revision 3061)
@@ -34,17 +34,28 @@
 	@Parameter(key = TXMPreferences.QUERY)
 	protected String pQuery;
 	
+	/**
+	 * from 0 to N-1 sentences
+	 */
+	@Parameter(key = TXMPreferences.INDEX)
+	protected int index;
+	
+	/**
+	 * from 0 to N-1 sentence subgraphs
+	 */
+	@Parameter(key = TXMPreferences.SUB_INDEX)
+	protected int subIndex;
+	
 	public CorpusBuild getCorpus() {
 		return corpus;
 	}
 	
-	public TIGERSearch(CorpusBuild corpus2) {
-		this(null, corpus2);
-		
+	public TIGERSearch(CorpusBuild corpus) {
+		this(null, corpus);
 	}
 	
-	public TIGERSearch(String parentNodePath, CorpusBuild corpus2) {
-		super(parentNodePath, corpus2);
+	public TIGERSearch(String parentNodePath, CorpusBuild corpus) {
+		super(parentNodePath, corpus);
 		
 		this.corpus = getParent();
 		
@@ -262,4 +273,9 @@
 	public String getResultType() {
 		return "Tiger search";
 	}
+	
+	public void setIndexAndSubIndex(int sent, int sub) {
+		this.index = sent;
+		this.subIndex = sub;
+	}
 }
